#include "setjmp.h"

typedef unsigned char SEMA; // 

//   
#define CON_ROWS 20
//   
#define CON_COLS 8

// 
typedef struct
{
 unsigned int tmr; //  1/
 SEMA *flag; //      0
} TIMER;

//  1
#define MAX_FAST_TIMERS		16
//  1
#define MAX_SLOW_TIMERS		16

#define STASK struct TASK
#define PTASK struct TASK *

//   
STASK
{
 jmp_buf jb; //  longjmp
 PTASK next; //  . 
 char TMR; //  0 - , 255 - 
 char HAVE_CON; // 0 -  
};

//   
typedef struct
{
 STASK; //    (   STASK)
 union
 {
  char flags;
  struct
  {
   char active:1, // 
        changed: 1, // 
        esc_curpos: 1, // .  . 
        waitkey:1, //  
        scrollbar:1; //   
  };
 };
 char cpos; // 
 unsigned int screen[CON_ROWS*CON_COLS]; // , .  - , .  - 
 char gfx[64]; //     (8 )
} CON_TASK;

extern char ElapsedRunIn1ms;

#define STOP_MT {ElapsedRunIn1ms=0;}
#define START_MT {ElapsedRunIn1ms=1;}

void InitMTOS(void);
__x void CreateTask(__task void (tsk(void))); // 
void InsertTask(PTASK t, char tmr, char havecon); //   
PTASK NextTask(void); //  . 
__x void AllocSema(SEMA *ps); // 
__x void FreeSema(SEMA *ps); // 

//   1m
TIMER * AllocFastTimer(SEMA *s); //     
//   1
TIMER * AllocSlowTimer(SEMA *s); //     

__monitor void SetTimer(TIMER *t, unsigned int tmr); //   tmr /

// /    1  2000 
__monitor unsigned long GetTimeDate(void);
// /    1  2000 
__monitor void SetTimeDate(unsigned long td);
//       (30 )
void SetupTimeDateCorrection(int sm);

// printf - char put_one_char(char)
int putchar(int); // 
int getchar(void); // 

//   
#define TASK_HEADER(rsize,csize,tmr) \
  static char RSTACK[rsize*2]; \
  static char CSTACK[csize]; \
  static STASK tsk; \
  { \
   SP=(unsigned int)(RSTACK+rsize*2-1); \
   *((unsigned int *)28)=(unsigned int)(CSTACK+csize); \
   InsertTask((PTASK)&tsk,tmr,0); \
  }

//   
#define CON_TASK_HEADER(rsize,csize,tmr) \
  static char RSTACK[rsize*2]; \
  static char CSTACK[csize]; \
  static CON_TASK tsk; \
  { \
    SP=(unsigned int)(RSTACK+rsize*2-1);\
   *((unsigned int *)28)=(unsigned int)(CSTACK+csize); \
   InsertTask((PTASK)&tsk,tmr,1); \
  }

// ,   
#define INT_TASK_HEADER(jb_name,rsize,csize) \
  static char RSTACK[rsize*2]; \
  static char CSTACK[csize]; \
  { \
   if (!setjmp(jb_name[1])) \
   { \
    SP=(unsigned int)(RSTACK+rsize*2-1); \
    *((unsigned int *)28)=(unsigned int)(CSTACK+csize); \
   } \
   else return; \
  }

